#include <strings.h>
#include <stdio.h>
#include <sys/types.h>
#include <machine/cpufunc.h>

void usage(char *progname) {
	fprintf(stderr,"Usage: %s [-w]\n",progname);
	exit(1);
}

void fatal(char *progname) {
	perror(progname);	
	exit(2);
}

/* write to cmos */
void wcmos() {
int i, ch;

	for (i=0 ; i<128 ; i++) {
	if ((ch = getchar())==EOF)
		break;
	outb(0x70,(char)i);
	outb(0x71,(char)ch);
	}
}

/* read from cmos */
void rcmos() {
	int i, ch;

	for (i=0 ; i<128 ; i++) {
		outb(0x70,i);
		ch = inb(0x71);
		putc(ch,stdout);
	}
}

main(int c,char **v) {
FILE *f;

if ((c>2) || (c>1 && strcmp(v[1],"-w"))) usage(v[0]);

/* allow access to I/O port space */
f = fopen("/dev/io","r");
if (f==NULL) fatal(v[0]);

if (c>1) wcmos(); else rcmos();

fclose(f);
return(0);
}
